diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/mesh/model/dot11s/peer-management-protocol-mac.h ns-3.34/src/mesh/model/dot11s/peer-management-protocol-mac.h
--- ns-3.33/src/mesh/model/dot11s/peer-management-protocol-mac.h	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/mesh/model/dot11s/peer-management-protocol-mac.h	2021-07-14 10:31:07.000000000 -0700
@@ -25,6 +25,8 @@
 
 namespace ns3 {
 class MeshWifiInterfaceMac;
+class WifiMacQueueItem;
+enum WifiMacDropReason : uint8_t;  // opaque enum declaration
 namespace dot11s {
 class PeerManagementProtocol;
 class IeConfiguration;
@@ -87,12 +89,23 @@
    * \return the assigned stream
    */
   int64_t AssignStreams (int64_t stream);
-  ///\name Statistics
-  // \{
+
+  /// \name Statistics
+  ///@{
+  /**
+   * \brief Report statistics
+   * \param os the output stream
+   */
   void Report (std::ostream &) const;
+  /// Reset stats
   void ResetStats ();
+  /**
+   * Get the link metric
+   * \param peerAddress the peer address
+   * \return The metric
+   */
   uint32_t GetLinkMetric (Mac48Address peerAddress);
-  // \}
+  ///@}
 
 private:
   /**
@@ -146,14 +159,15 @@
   // \}
   /**
    *  Closes link when a proper number of successive transmissions have failed
-   * \param hdr the header
+   * \param reason the reason why the MPDU was dropped
+   * \param mpdu the dropped MPDU
    */
-  void TxError (WifiMacHeader const &hdr);
+  void TxError (WifiMacDropReason reason, Ptr<const WifiMacQueueItem> mpdu);
   /**
    * Transmit OK function
-   * \param hdr the header
+   * \param mpdu the MPDU
    */
-  void TxOk (WifiMacHeader const &hdr);
+  void TxOk (Ptr <const WifiMacQueueItem> mpdu);
   // BCA functionality
   /**
    * Set beacon shift function
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/mesh/model/flame/flame-protocol.h ns-3.34/src/mesh/model/flame/flame-protocol.h
--- ns-3.33/src/mesh/model/flame/flame-protocol.h	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/mesh/model/flame/flame-protocol.h	2021-07-14 10:31:07.000000000 -0700
@@ -124,6 +124,7 @@
                            const Mac48Address destination, Ptr<Packet> packet, uint16_t& protocolType);
   /**
    * \brief Install FLAME on given mesh point.
+   * \param mp the MeshPointDevice
    * \returns true if successful
    *
    * Installing protocol causes installation of its interface MAC plugins.
@@ -131,7 +132,7 @@
    * Also MP aggregates all installed protocols, FLAME protocol can be accessed
    * via MeshPointDevice::GetObject<flame::FlameProtocol>();
    */
-  bool Install (Ptr<MeshPointDevice>);
+  bool Install (Ptr<MeshPointDevice> mp);
   /**
    * Get address of this instance
    * \returns the MAC address
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/mesh/model/mesh-point-device.h ns-3.34/src/mesh/model/mesh-point-device.h
--- ns-3.33/src/mesh/model/mesh-point-device.h	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/mesh/model/mesh-point-device.h	2021-07-14 10:31:07.000000000 -0700
@@ -39,7 +39,7 @@
  *   - Aggregating and coordinating 1..* real devices -- mesh interfaces, see MeshInterfaceDevice class.
  *   - Hosting all mesh-related level 2 protocols.
  *
- * One of hosted L2 protocols must inplement L2RoutingProtocol interface and is used for packets forwarding.
+ * One of hosted L2 protocols must implement L2RoutingProtocol interface and is used for packets forwarding.
  *
  * From the level 3 point of view MeshPointDevice is similar to BridgeNetDevice, but the packets,
  * which going through may be changed (because L2 protocols may require their own headers or tags).
@@ -59,8 +59,8 @@
   /// D-tor
   virtual ~MeshPointDevice ();
 
-  ///\name Interfaces
-  //\{
+  /// \name Interfaces
+  ///@{
   /**
    * \brief Attach new interface to the station. Interface must support 48-bit MAC address and SendFrom method.
    * \param port the port used
@@ -81,15 +81,24 @@
    * \return vector of interfaces
    */
   std::vector<Ptr<NetDevice> > GetInterfaces () const;
-  //\}
+  ///@}
 
-  ///\name Protocols
-  //\{
-  /// Register routing protocol to be used. Protocol must be already installed on this mesh point.
+
+  /// \name Protocols
+  ///@{
+  /**
+   * Register routing protocol to be used. Protocol must be already installed on this mesh point.
+   *
+   * \param protocol the routing protocol
+   */
   void SetRoutingProtocol (Ptr<MeshL2RoutingProtocol> protocol);
-  /// Access current routing protocol
+  /**
+   * Access current routing protocol
+   *
+   * \return the current routing protocol
+   */
   Ptr<MeshL2RoutingProtocol> GetRoutingProtocol () const;
-  //\}
+  ///@}
 
   // Inherited from NetDevice
   virtual void SetIfIndex (const uint32_t index);
@@ -118,13 +127,16 @@
   virtual Address GetMulticast (Ipv6Address addr) const;
   virtual void DoDispose ();
 
-  ///\name Statistics
-  //\{
-  /// Print statistics counters
+  /// \name Statistics
+  ///@{
+  /**
+   *  Print statistics counters
+   *  \param os the output stream
+   */
   void Report (std::ostream & os) const;
   /// Reset statistics counters
   void ResetStats ();
-  //\}
+  ///@}
 
 private:
   /**
@@ -197,7 +209,7 @@
     /// constructor
     Statistics ();
   };
-  /// Counters
+  // Counters
   Statistics m_rxStats; ///< receive statistics
   Statistics m_txStats; ///< transmit statistics
   Statistics m_fwdStats; ///< forward statistics
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/mesh/model/mesh-wifi-interface-mac.cc ns-3.34/src/mesh/model/mesh-wifi-interface-mac.cc
--- ns-3.33/src/mesh/model/mesh-wifi-interface-mac.cc	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/mesh/model/mesh-wifi-interface-mac.cc	2021-07-14 10:31:07.000000000 -0700
@@ -23,7 +23,6 @@
 #include "ns3/mesh-wifi-beacon.h"
 #include "ns3/log.h"
 #include "ns3/boolean.h"
-#include "ns3/mac-low.h"
 #include "ns3/random-variable-stream.h"
 #include "ns3/simulator.h"
 #include "ns3/yans-wifi-phy.h"
@@ -33,6 +32,7 @@
 #include "ns3/trace-source-accessor.h"
 #include "ns3/socket.h"
 #include "ns3/wifi-net-device.h"
+#include "ns3/channel-access-manager.h"
 
 namespace ns3 {
 
@@ -98,7 +98,7 @@
 MeshWifiInterfaceMac::Enqueue (Ptr<Packet> packet, Mac48Address to)
 {
   NS_LOG_FUNCTION (this << packet << to);
-  ForwardDown (packet, m_low->GetAddress (), to);
+  ForwardDown (packet, GetAddress (), to);
 }
 bool
 MeshWifiInterfaceMac::SupportsSendFrom () const
@@ -236,9 +236,9 @@
     {
       // in adhoc mode, we assume that every destination
       // supports all the rates we support.
-      for (uint32_t i = 0; i < m_phy->GetNModes (); i++)
+      for (const auto & mode : m_phy->GetModeList ())
         {
-          m_stationManager->AddSupportedMode (hdr.GetAddr1 (), m_phy->GetMode (i));
+          m_stationManager->AddSupportedMode (hdr.GetAddr1 (), mode);
         }
       m_stationManager->RecordDisassociated (hdr.GetAddr1 ());
     }
@@ -303,9 +303,8 @@
   // set the set of supported rates and make sure that we indicate
   // the Basic Rate set in this set of supported rates.
   SupportedRates rates;
-  for (uint32_t i = 0; i < m_phy->GetNModes (); i++)
+  for (const auto & mode : m_phy->GetModeList ())
     {
-      WifiMode mode = m_phy->GetMode (i);
       uint16_t gi = ConvertGuardIntervalToNanoSeconds (mode, DynamicCast<WifiNetDevice> (m_phy->GetDevice ()));
       rates.AddSupportedRate (mode.GetDataRate (m_phy->GetChannelWidth (), gi, 1));
     }
@@ -431,9 +430,8 @@
         {
           SupportedRates rates = beacon_hdr.GetSupportedRates ();
 
-          for (uint32_t i = 0; i < m_phy->GetNModes (); i++)
+          for (const auto & mode : m_phy->GetModeList ())
             {
-              WifiMode mode = m_phy->GetMode (i);
               uint16_t gi = ConvertGuardIntervalToNanoSeconds (mode, DynamicCast<WifiNetDevice> (m_phy->GetDevice ()));
               uint64_t rate = mode.GetDataRate (m_phy->GetChannelWidth (), gi, 1);
               if (rates.IsSupportedRate (rate))
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/mesh/model/mesh-wifi-interface-mac.h ns-3.34/src/mesh/model/mesh-wifi-interface-mac.h
--- ns-3.33/src/mesh/model/mesh-wifi-interface-mac.h	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/mesh/model/mesh-wifi-interface-mac.h	2021-07-14 10:31:07.000000000 -0700
@@ -65,16 +65,32 @@
   virtual void  Enqueue (Ptr<Packet> packet, Mac48Address to);
   virtual bool  SupportsSendFrom () const;
   virtual void  SetLinkUpCallback (Callback<void> linkUp);
-  ///\name Each mesh point interface must know the mesh point address
-  // \{
-  void SetMeshPointAddress (Mac48Address);
+
+  /// \name Each mesh point interface must know the mesh point address
+  ///@{
+  /**
+   * Set the mesh point address
+   * \param addr the mesh point address
+   */
+  void SetMeshPointAddress (Mac48Address addr);
+  /**
+   * Get the mesh point address
+   * \return The mesh point address
+   */
   Mac48Address GetMeshPointAddress () const;
-  // \}
-  ///\name Beacons
-  // \{
-  /// Set maximum initial random delay before first beacon
+  ///@}
+
+  /// \name Beacons
+  ///@{
+  /**
+   *  Set maximum initial random delay before first beacon
+   *  \param interval maximum random interval
+   */
   void SetRandomStartDelay (Time interval);
-  /// Set interval between two successive beacons
+  /**
+   *  Set interval between two successive beacons
+   *  \param interval beacon interval
+   */
   void SetBeaconInterval (Time interval);
   /// \return interval between two beacons
   Time GetBeaconInterval () const;
@@ -94,7 +110,7 @@
    * \attention User of ShiftTbtt () must take care to not shift it to the past.
    */
   void ShiftTbtt (Time shift);
-  // \}
+  ///@}
 
   /**
    * Install plugin.
@@ -140,15 +156,30 @@
   bool CheckSupportedRates (SupportedRates rates) const;
   /// \return list of supported bitrates
   SupportedRates GetSupportedRates () const;
-  ///\name Metric Calculation routines:
-  // \{
+
+  /// \name Metric Calculation routines:
+  ///@{
+  /**
+   * Set the link metric callback
+   * \param cb the callback
+   */
   void SetLinkMetricCallback (Callback<uint32_t, Mac48Address, Ptr<MeshWifiInterfaceMac> > cb);
+  /**
+   * Get the link metric
+   * \param peerAddress the peer address
+   * \return The metric
+   */
   uint32_t GetLinkMetric (Mac48Address peerAddress);
-  // \}
-  ///\brief Statistics:
-  void Report (std::ostream &) const;
-  /// Reset statistics
+  ///@}
+
+  /**
+   * \brief Report statistics
+   * \param os the output stream
+   */
+  void Report (std::ostream & os) const;
+  /// Reset statistics function
   void ResetStats ();
+
   /**
    * Enable/disable beacons
    *
@@ -203,8 +234,8 @@
 
   virtual void DoInitialize ();
 
-  ///\name Mesh timing intervals
-  // \{
+  /// \name Mesh timing intervals
+  ///@{
   /// whether beaconing is enabled
   bool m_beaconEnable;
   /// Beaconing interval.
@@ -213,7 +244,7 @@
   Time m_randomStart;
   /// Time for the next frame
   Time m_tbtt;
-  // \}
+  ///@}
 
   /// Mesh point address
   Mac48Address m_mpAddress;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/mobility/bindings/modulegen__gcc_ILP32.py ns-3.34/src/mobility/bindings/modulegen__gcc_ILP32.py
--- ns-3.33/src/mobility/bindings/modulegen__gcc_ILP32.py	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/mobility/bindings/modulegen__gcc_ILP32.py	2021-07-14 10:31:07.000000000 -0700
@@ -85,12 +85,16 @@
     module.add_class('Ipv4Address', import_from_module='ns.network')
     ## ipv4-address.h (module 'network'): ns3::Ipv4Address [class]
     root_module['ns3::Ipv4Address'].implicitly_converts_to(root_module['ns3::Address'])
+    ## ipv4-address.h (module 'network'): ns3::Ipv4AddressHash [class]
+    module.add_class('Ipv4AddressHash', import_from_module='ns.network')
     ## ipv4-address.h (module 'network'): ns3::Ipv4Mask [class]
     module.add_class('Ipv4Mask', import_from_module='ns.network')
     ## ipv6-address.h (module 'network'): ns3::Ipv6Address [class]
     module.add_class('Ipv6Address', import_from_module='ns.network')
     ## ipv6-address.h (module 'network'): ns3::Ipv6Address [class]
     root_module['ns3::Ipv6Address'].implicitly_converts_to(root_module['ns3::Address'])
+    ## ipv6-address.h (module 'network'): ns3::Ipv6AddressHash [class]
+    module.add_class('Ipv6AddressHash', import_from_module='ns.network')
     ## ipv6-address.h (module 'network'): ns3::Ipv6Prefix [class]
     module.add_class('Ipv6Prefix', import_from_module='ns.network')
     ## log.h (module 'core'): ns3::LogComponent [class]
@@ -527,8 +531,10 @@
     register_Ns3GeographicPositions_methods(root_module, root_module['ns3::GeographicPositions'])
     register_Ns3Hasher_methods(root_module, root_module['ns3::Hasher'])
     register_Ns3Ipv4Address_methods(root_module, root_module['ns3::Ipv4Address'])
+    register_Ns3Ipv4AddressHash_methods(root_module, root_module['ns3::Ipv4AddressHash'])
     register_Ns3Ipv4Mask_methods(root_module, root_module['ns3::Ipv4Mask'])
     register_Ns3Ipv6Address_methods(root_module, root_module['ns3::Ipv6Address'])
+    register_Ns3Ipv6AddressHash_methods(root_module, root_module['ns3::Ipv6AddressHash'])
     register_Ns3Ipv6Prefix_methods(root_module, root_module['ns3::Ipv6Prefix'])
     register_Ns3LogComponent_methods(root_module, root_module['ns3::LogComponent'])
     register_Ns3Mac48Address_methods(root_module, root_module['ns3::Mac48Address'])
@@ -1579,6 +1585,18 @@
                    [param('char const *', 'address')])
     return
 
+def register_Ns3Ipv4AddressHash_methods(root_module, cls):
+    ## ipv4-address.h (module 'network'): ns3::Ipv4AddressHash::Ipv4AddressHash() [constructor]
+    cls.add_constructor([])
+    ## ipv4-address.h (module 'network'): ns3::Ipv4AddressHash::Ipv4AddressHash(ns3::Ipv4AddressHash const & arg0) [constructor]
+    cls.add_constructor([param('ns3::Ipv4AddressHash const &', 'arg0')])
+    ## ipv4-address.h (module 'network'): size_t ns3::Ipv4AddressHash::operator()(ns3::Ipv4Address const & x) const [member operator]
+    cls.add_method('operator()', 
+                   'size_t', 
+                   [param('ns3::Ipv4Address const &', 'x')], 
+                   custom_name='__call__', is_const=True)
+    return
+
 def register_Ns3Ipv4Mask_methods(root_module, cls):
     cls.add_output_stream_operator()
     cls.add_binary_comparison_operator('==')
@@ -1792,6 +1810,11 @@
                    'ns3::Ipv6Address', 
                    [param('ns3::Address', 'addr'), param('ns3::Ipv6Address', 'prefix')], 
                    is_static=True)
+    ## ipv6-address.h (module 'network'): static ns3::Ipv6Address ns3::Ipv6Address::MakeAutoconfiguredAddress(ns3::Address addr, ns3::Ipv6Prefix prefix) [member function]
+    cls.add_method('MakeAutoconfiguredAddress', 
+                   'ns3::Ipv6Address', 
+                   [param('ns3::Address', 'addr'), param('ns3::Ipv6Prefix', 'prefix')], 
+                   is_static=True)
     ## ipv6-address.h (module 'network'): static ns3::Ipv6Address ns3::Ipv6Address::MakeAutoconfiguredAddress(ns3::Mac16Address addr, ns3::Ipv6Address prefix) [member function]
     cls.add_method('MakeAutoconfiguredAddress', 
                    'ns3::Ipv6Address', 
@@ -1867,6 +1890,18 @@
                    [param('uint8_t *', 'address')])
     return
 
+def register_Ns3Ipv6AddressHash_methods(root_module, cls):
+    ## ipv6-address.h (module 'network'): ns3::Ipv6AddressHash::Ipv6AddressHash() [constructor]
+    cls.add_constructor([])
+    ## ipv6-address.h (module 'network'): ns3::Ipv6AddressHash::Ipv6AddressHash(ns3::Ipv6AddressHash const & arg0) [constructor]
+    cls.add_constructor([param('ns3::Ipv6AddressHash const &', 'arg0')])
+    ## ipv6-address.h (module 'network'): size_t ns3::Ipv6AddressHash::operator()(ns3::Ipv6Address const & x) const [member operator]
+    cls.add_method('operator()', 
+                   'size_t', 
+                   [param('ns3::Ipv6Address const &', 'x')], 
+                   custom_name='__call__', is_const=True)
+    return
+
 def register_Ns3Ipv6Prefix_methods(root_module, cls):
     cls.add_output_stream_operator()
     cls.add_binary_comparison_operator('==')
@@ -1887,6 +1922,11 @@
     cls.add_constructor([param('ns3::Ipv6Prefix const &', 'prefix')])
     ## ipv6-address.h (module 'network'): ns3::Ipv6Prefix::Ipv6Prefix(ns3::Ipv6Prefix const * prefix) [constructor]
     cls.add_constructor([param('ns3::Ipv6Prefix const *', 'prefix')])
+    ## ipv6-address.h (module 'network'): ns3::Ipv6Address ns3::Ipv6Prefix::ConvertToIpv6Address() const [member function]
+    cls.add_method('ConvertToIpv6Address', 
+                   'ns3::Ipv6Address', 
+                   [], 
+                   is_const=True)
     ## ipv6-address.h (module 'network'): void ns3::Ipv6Prefix::GetBytes(uint8_t * buf) const [member function]
     cls.add_method('GetBytes', 
                    'void', 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/mobility/bindings/modulegen__gcc_LP64.py ns-3.34/src/mobility/bindings/modulegen__gcc_LP64.py
--- ns-3.33/src/mobility/bindings/modulegen__gcc_LP64.py	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/mobility/bindings/modulegen__gcc_LP64.py	2021-07-14 10:31:07.000000000 -0700
@@ -85,12 +85,16 @@
     module.add_class('Ipv4Address', import_from_module='ns.network')
     ## ipv4-address.h (module 'network'): ns3::Ipv4Address [class]
     root_module['ns3::Ipv4Address'].implicitly_converts_to(root_module['ns3::Address'])
+    ## ipv4-address.h (module 'network'): ns3::Ipv4AddressHash [class]
+    module.add_class('Ipv4AddressHash', import_from_module='ns.network')
     ## ipv4-address.h (module 'network'): ns3::Ipv4Mask [class]
     module.add_class('Ipv4Mask', import_from_module='ns.network')
     ## ipv6-address.h (module 'network'): ns3::Ipv6Address [class]
     module.add_class('Ipv6Address', import_from_module='ns.network')
     ## ipv6-address.h (module 'network'): ns3::Ipv6Address [class]
     root_module['ns3::Ipv6Address'].implicitly_converts_to(root_module['ns3::Address'])
+    ## ipv6-address.h (module 'network'): ns3::Ipv6AddressHash [class]
+    module.add_class('Ipv6AddressHash', import_from_module='ns.network')
     ## ipv6-address.h (module 'network'): ns3::Ipv6Prefix [class]
     module.add_class('Ipv6Prefix', import_from_module='ns.network')
     ## log.h (module 'core'): ns3::LogComponent [class]
@@ -527,8 +531,10 @@
     register_Ns3GeographicPositions_methods(root_module, root_module['ns3::GeographicPositions'])
     register_Ns3Hasher_methods(root_module, root_module['ns3::Hasher'])
     register_Ns3Ipv4Address_methods(root_module, root_module['ns3::Ipv4Address'])
+    register_Ns3Ipv4AddressHash_methods(root_module, root_module['ns3::Ipv4AddressHash'])
     register_Ns3Ipv4Mask_methods(root_module, root_module['ns3::Ipv4Mask'])
     register_Ns3Ipv6Address_methods(root_module, root_module['ns3::Ipv6Address'])
+    register_Ns3Ipv6AddressHash_methods(root_module, root_module['ns3::Ipv6AddressHash'])
     register_Ns3Ipv6Prefix_methods(root_module, root_module['ns3::Ipv6Prefix'])
     register_Ns3LogComponent_methods(root_module, root_module['ns3::LogComponent'])
     register_Ns3Mac48Address_methods(root_module, root_module['ns3::Mac48Address'])
@@ -1579,6 +1585,18 @@
                    [param('char const *', 'address')])
     return
 
+def register_Ns3Ipv4AddressHash_methods(root_module, cls):
+    ## ipv4-address.h (module 'network'): ns3::Ipv4AddressHash::Ipv4AddressHash() [constructor]
+    cls.add_constructor([])
+    ## ipv4-address.h (module 'network'): ns3::Ipv4AddressHash::Ipv4AddressHash(ns3::Ipv4AddressHash const & arg0) [constructor]
+    cls.add_constructor([param('ns3::Ipv4AddressHash const &', 'arg0')])
+    ## ipv4-address.h (module 'network'): size_t ns3::Ipv4AddressHash::operator()(ns3::Ipv4Address const & x) const [member operator]
+    cls.add_method('operator()', 
+                   'size_t', 
+                   [param('ns3::Ipv4Address const &', 'x')], 
+                   custom_name='__call__', is_const=True)
+    return
+
 def register_Ns3Ipv4Mask_methods(root_module, cls):
     cls.add_output_stream_operator()
     cls.add_binary_comparison_operator('==')
@@ -1792,6 +1810,11 @@
                    'ns3::Ipv6Address', 
                    [param('ns3::Address', 'addr'), param('ns3::Ipv6Address', 'prefix')], 
                    is_static=True)
+    ## ipv6-address.h (module 'network'): static ns3::Ipv6Address ns3::Ipv6Address::MakeAutoconfiguredAddress(ns3::Address addr, ns3::Ipv6Prefix prefix) [member function]
+    cls.add_method('MakeAutoconfiguredAddress', 
+                   'ns3::Ipv6Address', 
+                   [param('ns3::Address', 'addr'), param('ns3::Ipv6Prefix', 'prefix')], 
+                   is_static=True)
     ## ipv6-address.h (module 'network'): static ns3::Ipv6Address ns3::Ipv6Address::MakeAutoconfiguredAddress(ns3::Mac16Address addr, ns3::Ipv6Address prefix) [member function]
     cls.add_method('MakeAutoconfiguredAddress', 
                    'ns3::Ipv6Address', 
@@ -1867,6 +1890,18 @@
                    [param('uint8_t *', 'address')])
     return
 
+def register_Ns3Ipv6AddressHash_methods(root_module, cls):
+    ## ipv6-address.h (module 'network'): ns3::Ipv6AddressHash::Ipv6AddressHash() [constructor]
+    cls.add_constructor([])
+    ## ipv6-address.h (module 'network'): ns3::Ipv6AddressHash::Ipv6AddressHash(ns3::Ipv6AddressHash const & arg0) [constructor]
+    cls.add_constructor([param('ns3::Ipv6AddressHash const &', 'arg0')])
+    ## ipv6-address.h (module 'network'): size_t ns3::Ipv6AddressHash::operator()(ns3::Ipv6Address const & x) const [member operator]
+    cls.add_method('operator()', 
+                   'size_t', 
+                   [param('ns3::Ipv6Address const &', 'x')], 
+                   custom_name='__call__', is_const=True)
+    return
+
 def register_Ns3Ipv6Prefix_methods(root_module, cls):
     cls.add_output_stream_operator()
     cls.add_binary_comparison_operator('==')
@@ -1887,6 +1922,11 @@
     cls.add_constructor([param('ns3::Ipv6Prefix const &', 'prefix')])
     ## ipv6-address.h (module 'network'): ns3::Ipv6Prefix::Ipv6Prefix(ns3::Ipv6Prefix const * prefix) [constructor]
     cls.add_constructor([param('ns3::Ipv6Prefix const *', 'prefix')])
+    ## ipv6-address.h (module 'network'): ns3::Ipv6Address ns3::Ipv6Prefix::ConvertToIpv6Address() const [member function]
+    cls.add_method('ConvertToIpv6Address', 
+                   'ns3::Ipv6Address', 
+                   [], 
+                   is_const=True)
     ## ipv6-address.h (module 'network'): void ns3::Ipv6Prefix::GetBytes(uint8_t * buf) const [member function]
     cls.add_method('GetBytes', 
                    'void', 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/mobility/examples/main-random-topology.cc ns-3.34/src/mobility/examples/main-random-topology.cc
--- ns-3.33/src/mobility/examples/main-random-topology.cc	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/mobility/examples/main-random-topology.cc	2021-07-14 10:31:07.000000000 -0700
@@ -22,6 +22,11 @@
 
 using namespace ns3;
 
+/**
+ * Function called when there is a course change
+ * \param context event context
+ * \param position a pointer to the mobility model
+ */
 static void 
 CourseChange (std::string context, Ptr<const MobilityModel> position)
 {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/mobility/examples/main-random-walk.cc ns-3.34/src/mobility/examples/main-random-walk.cc
--- ns-3.33/src/mobility/examples/main-random-walk.cc	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/mobility/examples/main-random-walk.cc	2021-07-14 10:31:07.000000000 -0700
@@ -21,8 +21,13 @@
 
 using namespace ns3;
 
+/**
+ * Function called when there is a course change
+ * \param context event context
+ * \param mobility a pointer to the mobility model
+ */
 static void 
-CourseChange (std::string foo, Ptr<const MobilityModel> mobility)
+CourseChange (std::string context, Ptr<const MobilityModel> mobility)
 {
   Vector pos = mobility->GetPosition ();
   Vector vel = mobility->GetVelocity ();
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/mobility/helper/ns2-mobility-helper.cc ns-3.34/src/mobility/helper/ns2-mobility-helper.cc
--- ns-3.33/src/mobility/helper/ns2-mobility-helper.cc	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/mobility/helper/ns2-mobility-helper.cc	2021-07-14 10:31:07.000000000 -0700
@@ -103,16 +103,22 @@
 
 /**
  * Parses a line of ns2 mobility
+ * \param str the string to parse
+ * \returns The parsed line
  */
 static ParseResult ParseNs2Line (const std::string& str);
 
 /** 
  * Put out blank spaces at the start and end of a line
+ * \param str input line
+ * \returns the line trimmed
  */
 static std::string TrimNs2Line (const std::string& str);
 
 /**
- * Checks if a string represents a number or it has others characters than digits an point.
+ * Checks if a string represents a number or it has others characters than digits and point.
+ * \param s the string to check
+ * \returns true if the string represents a number
  */
 static bool IsNumber (const std::string& s);
 
@@ -127,57 +133,91 @@
 
 /**
  * Checks if the value between brackets is a correct nodeId number
+ * \param str string to check
+ * \returns true if the string represents a nodeId number
  */ 
 static bool HasNodeIdNumber (std::string str);
 
 /** 
  * Gets nodeId number in string format from the string like $node_(4)
+ * \param str string to de-tokenize
+ * \returns A string with the nodeId number
  */
 static std::string GetNodeIdFromToken (std::string str);
 
 /** 
  * Get node id number in int format
+ * \param pr the ParseResult to analyze
+ * \returns the node ID (as an int)
  */
 static int GetNodeIdInt (ParseResult pr);
 
 /**  
  * Get node id number in string format
+ * \param pr the ParseResult to analyze
+ * \returns the node ID (as a string)
  */
 static std::string GetNodeIdString (ParseResult pr);
 
 /**
  * Add one coord to a vector position
+ * \param actPos actual position (overwritten)
+ * \param coord coordinate (x, y, or z)
+ * \param value value of the coordinate
+ * \return The vector of the position
  */
 static Vector SetOneInitialCoord (Vector actPos, std::string& coord, double value);
 
 /** 
  * Check if this corresponds to a line like this: $node_(0) set X_ 123
+ * \param pr the ParseResult to analyze
+ * \returns true if the ParseResult looks like a coordinate without a scheduled time
  */
 static bool IsSetInitialPos (ParseResult pr);
 
 /** 
  * Check if this corresponds to a line like this: $ns_ at 1 "$node_(0) setdest 2 3 4"
+ * \param pr the ParseResult to analyze
+ * \returns true if the ParseResult looks like a coordinate with a scheduled time and destionation
  */
 static bool IsSchedSetPos (ParseResult pr);
 
 /**
  * Check if this corresponds to a line like this: $ns_ at 1 "$node_(0) set X_ 2"
+ * \param pr the ParseResult to analyze
+ * \returns true if the ParseResult looks like a coordinate with a scheduled time
  */
 static bool IsSchedMobilityPos (ParseResult pr);
 
 /**
  * Set waypoints and speed for movement.
+ * \param model mobility model
+ * \param lastPos last position
+ * \param at initial movement time
+ * \param xFinalPosition final position (X axis)
+ * \param yFinalPosition final position (Y axis)
+ * \param speed movement speed
+ * \returns A descriptor of the movement
  */
 static DestinationPoint SetMovement (Ptr<ConstantVelocityMobilityModel> model, Vector lastPos, double at,
                                      double xFinalPosition, double yFinalPosition, double speed);
 
 /**
  * Set initial position for a node
+ * \param model mobility model
+ * \param coord coordinate (x, y, or z)
+ * \param coordVal value of the coordinate
+ * \return The vector of the position
  */
 static Vector SetInitialPosition (Ptr<ConstantVelocityMobilityModel> model, std::string coord, double coordVal);
 
 /** 
  * Schedule a set of position for a node
+ * \param model mobility model
+ * \param at initial movement time
+ * \param coord coordinate (x, y, or z)
+ * \param coordVal value of the coordinate
+ * \return The vector of the position at the given time
  */
 static Vector SetSchedPosition (Ptr<ConstantVelocityMobilityModel> model, double at, std::string coord, double coordVal);
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/mobility/model/hierarchical-mobility-model.h ns-3.34/src/mobility/model/hierarchical-mobility-model.h
--- ns-3.33/src/mobility/model/hierarchical-mobility-model.h	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/mobility/model/hierarchical-mobility-model.h	2021-07-14 10:31:07.000000000 -0700
@@ -104,10 +104,12 @@
 
   /**
    * Callback for when parent mobility model course change occurs
+   * \param model mobility mode (unused)
    */
   void ParentChanged (Ptr<const MobilityModel> model);
   /**
    * Callback for when child mobility model course change occurs
+   * \param model mobility mode (unused)
    */
   void ChildChanged (Ptr<const MobilityModel> model);
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/mobility/model/position-allocator.h ns-3.34/src/mobility/model/position-allocator.h
--- ns-3.33/src/mobility/model/position-allocator.h	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/mobility/model/position-allocator.h	2021-07-14 10:31:07.000000000 -0700
@@ -88,7 +88,7 @@
    * \brief Add the positions listed in a file.
    * The file should be a simple text file, with one position per line,
    * either X and Y, or X, Y and Z, in meters.  The delimiter can
-   * be any character, such as ',' or '\t'; the default is a comma ','.
+   * be any character, such as ',' or '\\t'; the default is a comma ','.
    *
    * The file is read using CsvReader, which explains how comments
    * and whitespace are handled.
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/mobility/model/random-walk-2d-mobility-model.h ns-3.34/src/mobility/model/random-walk-2d-mobility-model.h
--- ns-3.33/src/mobility/model/random-walk-2d-mobility-model.h	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/mobility/model/random-walk-2d-mobility-model.h	2021-07-14 10:31:07.000000000 -0700
@@ -66,6 +66,7 @@
   /**
    * Walk according to position and velocity, until distance is reached,
    * time is reached, or intersection with the bounding box
+   * \param timeLeft The remaining time of the walk
    */
   void DoWalk (Time timeLeft);
   /**
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/mobility/model/waypoint-mobility-model.h ns-3.34/src/mobility/model/waypoint-mobility-model.h
--- ns-3.33/src/mobility/model/waypoint-mobility-model.h	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/mobility/model/waypoint-mobility-model.h	2021-07-14 10:31:07.000000000 -0700
@@ -111,12 +111,14 @@
 
   /**
    * Get the waypoint that this object is traveling towards.
+   * \returns The waypoint
    */
   Waypoint GetNextWaypoint (void) const;
 
   /**
    * Get the number of waypoints left for this object, excluding
    * the next one.
+   * \returns The number of waypoints left
    */
   uint32_t WaypointsLeft (void) const;
 
